/*日夜间共用js*/

/* 对于复杂的js，若日夜间代码仅有一两行日夜间的差距，可使用 ifeng.isNightMode(); 进行判断区分，将该复杂js代码放入此js，利于维护 */

var video_p = '<!-- IFENG_DOC_VIDEO -->';
var slide_p = '<!-- IFENG_DOC_SLIDE -->';
var center_ad_p='<!-- IFENG_DOC_ADVERT -->';

/*房产相关*/
var houselp_p='<!-- IFENG_DOC_HOUSEBUILDING -->';
var housefy_p='<!-- IFENG_DOC_HOUSERESOURCES -->';
var housexq_p='<!-- IFENG_DOC_HOUSEESTATE -->';
var housedc_p='<!-- IFENG_DOC_HOUSESURVEY -->';
var househd_p='<!-- IFENG_DOC_HOUSEACTIVITY -->';

/*html占位 原生控件渲染。需要按顺序加载，详见 DocPlaceHolderRender */
var survey_p= '<!-- IFENG_DOC_SURVEY -->';
var audio_p = '<!-- IFENG_DOC_AUDIO -->';
var ifeng_doc_ad_p = '<!-- IFENG_DOC_AD -->';
var card_ad_p = '<!-- IFENG_DOC_CARD -->';


var EVENT_IMG_WIDTH = 0;                        //运营位活动图片宽
var EVENT_IMG_HEIGHT = 0;                       //运营位活动图片高
var EVENT_IMG_RADIO = 698 / 256;                //运营位活动图片宽高比
var IMGE_DEFAULT_HEIGHT = 90.5;
var IMAGE_PLACEHOLDER_WIDTH;
var IMAGE_PLACEHOLDER_HEIGHT;
var PLACEHOLDER_SLOPE = 174 / 294;              // 标准框比例
var VIDEO_SLOP = 9/16;                          // 视频宽高比
var BODY_AD_CENTER_RADIO = 480 / 400;           // 正文中间通发广告宽高比
var BODY_AD_RADIO = 668 / 202;                  // 正文广告宽高比


var class_iwords = 'iwords';
var FONTS={
    'small'    : 0,
    'mid'      : 1,
    'big'      : 2,
    'bigger'   : 3,
};
var jumpUrls = [];
var cropper;
var FIRSTFONT;
var image_index=0;
var SCREEN_WIDTH;
var imgQuene = [];
var srcs = [];
var topFlag = 0;

var originalHeight;
var loadImagesTaskId;


// 监听 load 事件 执行 prepare 方法初始化逻辑
window.addEventListener('load', prepare, false);

var retryCount = 0;
var RETRY_INTERVAL = 10;
var MAX_RETRY_TIMES = 100;

function prepare() {

    console.log("prepare");

    initBaseData();

    judgeAvailable();
}

/**
 * 判定当前是否可以正常使用
 *
 * 当load回调直接执行给div内部设置文字时，该div虽然高度显示无问题，但高度获取、对下方其他dom的影响都是错误的（偶现）
 * 如标题，该div的高度会错误，导致下方其他dom获取上边距全部错误，反复测试发现是时机过早，但具体原因还未查出，
 * 此处可以正常获取到document.body.clientWidth时开始执行渲染方法
 */
function judgeAvailable() {

    console.log("judgeAvailable clientWidth : " + document.body.clientWidth + ",retryCount:" + retryCount);

    if (document.body.clientWidth || retryCount > MAX_RETRY_TIMES) {
        init();
    } else {
        retryCount++;
        setTimeout(function() {
            judgeAvailable();
        }, RETRY_INTERVAL);
    }
}

function init() {

    console.log("init");

    renderDocBody();

    // 处理图片后 填充正文内容
    preprocessImage(formatText(datas.getTransFormText()),document.getElementById('content'), datas.getShortDocRelateTitleFontSize());

    // a标签跳转
    dealwithTextAtag(document.getElementById('content'));

    dealTelephoneComponent();

    fixErrorSpace();

    ifeng.startRenderPlaceHolderViews();
}


function initBaseData() {

    imgQuene = [];
    jumpUrls = [];
    srcs = [];

    resetImgLabel();

    athene.clear();
    athene.setUpdateTime(ifeng.getUpdateTime());

    //通过native方法获取设备宽度的DP值
    SCREEN_WIDTH = ifeng.getScreenWidth();
    console.log("SCREEN_WIDTH:" + SCREEN_WIDTH);

    var content = document.getElementById('content');
    if(content != null && content != undefined) {
        originalHeight = content.clientHeight;
    }

    IMAGE_PLACEHOLDER_WIDTH = SCREEN_WIDTH - 26;
    IMAGE_PLACEHOLDER_HEIGHT = Math.round(IMAGE_PLACEHOLDER_WIDTH * PLACEHOLDER_SLOPE);
    cropper = new ImageCropper(new StandPlaceholderCropStrategy(IMAGE_PLACEHOLDER_WIDTH));
}

function renderDocBody() {

    // 写入标题
    initNewsTitle();

    // 稿源
    initSource(datas);

    //软文广告标识
    initAdvertFlag(datas);

    //观点
    initViewPoint(datas);


    // 设置简介
    initSummary(datas.getSummary());

    // 设置AI简介
    initAiIntroView()

    // 设置大小字体
	setFontSize(datas.getFontSize(),
	    datas.getDocTitleFontSize(),
	    datas.getDocContentFontSize(),
	    datas.getSummaryFontSize(),
	    false);


    //展示 正文开始标签
    initDocStart(datas);

    // 增加作者和责任编辑
    initEditorCode(datas.getAuthor(), datas.getEditorcode());

    // 初始化免责声明
    initClaimer(datas.getDisclaimer(), datas.getOriginalLink());

    // 设置图注字体
    setPicIntroFontSize(datas.getFontSize(), datas.getPicIntroFontSize());

    // 获取自媒体信息底部的Y值
    setAuthorTitleBottomY();
}

function getLoadingImage() {

    var isNightMode = ifeng.isNightMode();
    if (isNightMode) {
        return '<img src="detail_image_loading_night.png" class="load-message">';
    } else {
        return '<img src="detail_image_loading.png" class="load-message">';
    }
}

// 获取自媒体信息底部的Y值
function setAuthorTitleBottomY(){
    var author_bottom = document.getElementById('author_bottom');
    if (author_bottom != null) {
        var authorBottom = author_bottom.offsetTop ;
        ifeng.setAuthorTitleBottomYDp(authorBottom);
        console.log("setAuthorTitleBottomYDp : " + authorBottom);
    }
}

//改变订阅图标状态 （于Java调用）
function changeSubButtonImg(subState) {
    try{
        var newsType = ifeng.getNewsType();
        subSourceSuccessForDoc().call(null, subState);
    } catch (e) {
       console.log("error:"+e);
    }
}
//订阅 观点人设
function changeSubViewPointButtonImg(subState) {
    try{
        subSourceSuccessForViewPoint().call(null,subState);
    } catch (e) {
       console.log("error:"+e);
    }
}

function hideFeedShowSub(){
    var feedback = document.getElementById('feedback');
    feedback.style.display = 'none';
    var subButton = document.getElementById('subscribe');
    if(datas.getSubscribe()!= null && datas.getSubscribe().getForbidFollow()!='1'){
         subButton.style.display = "block";
    }
}


function showBottomEventImg(imgUrl,isAuth,staticId) {
    SCREEN_WIDTH = ifeng.getScreenWidth();
    //运营位图片宽度 = 屏幕宽度 - 两边间距30px - 描边2px
    EVENT_IMG_WIDTH =  SCREEN_WIDTH - 30 - 2;
    //根据宽度和宽高比得到高度
    EVENT_IMG_HEIGHT = Math.round(EVENT_IMG_WIDTH / EVENT_IMG_RADIO);
    if(EVENT_IMG_HEIGHT <= 0) {
        return
    }
    var eventImgWrapper = document.getElementById('event_img_wrapper');
    eventImgWrapper.style.display = 'block';
    eventImgWrapper.onclick = function() {
       ifeng.onEventImgClick(isAuth,staticId);
    }
    var eventImage = document.getElementById('event_img');
    eventImage.style.height = EVENT_IMG_HEIGHT + 'px';
    eventImage.style.backgroundImage = 'url(' + imgUrl + ')';

    ifeng.refreshWebWrapperHeightIfFromFold();
}

function removeNotePreEmptyPBottomSpace(className) {

    if(!className || className == "" || className == 'undefined') {
        return;
    }

    try {
        //如果前一个标签是空p标签，将其下边距去掉
        var nodeList = document.getElementsByClassName(className)
        if(nodeList){
        console.log("removeNotePreEmptyPBottomSpace");
            for(var j=0;j<nodeList.length;j++) {
                 var pre = nodeList[j].previousSibling;
                 if(pre && pre.tagName == 'P' && pre.innerText == ""){
					if (isFieldValidAllowEmpty(pre.style.paddingBottom)) {
					    pre.style.paddingBottom = "0px";
					}

					if (isFieldValidAllowEmpty(pre.style.marginBottom)) {
					    pre.style.marginBottom = "0px";
					}

					console.log("fixErrorSpace success");
                 } else if(className == 'survey_classes') {
                    fixSurveyErrorTopSpace(pre);
                 }
            }
        }
    } catch (e) {
        console.log("removeNotePreEmptyPBottomSpace error : " + e);
    }
}

function fixSurveyErrorTopSpace(preNode) {
    if(!preNode) {
        return;
    }

    try {
        if(preNode.nodeType == 1){
            if(!preNode.style.paddingBottom && !preNode.style.marginBottom) {
                preNode.style.paddingBottom = "0px";
                preNode.style.marginBottom = "16px";
            }
        } else {
            fixSurveyErrorTopSpace(preNode.previousSibling);
        }
    } catch (e) {
        console.log("fixErrorTopSpace error : " + e);
    }
}

//修复正文异常边距
function fixErrorSpace() {
    try {
        var content = document.getElementById("content");

        removeNotePreEmptyPBottomSpace("video");
        removeNotePreEmptyPBottomSpace("placeholder_load_fail");

        fixTopVideoOrImgTopSpace();

        //移除正文最后一个元素的下边距
        removeLastElementBottomSpace(content);

        removeErrorPlaceHolderBottomSpace();

        console.log("fixErrorSpace");
    } catch (e) {
        console.log("fixErrorSpace error:" + e);
    }
}

/*移除该元素及其最后一个子元素底部的padding和margin*/
function removeLastElementBottomSpace(parent) {
    if(parent) {

        if (isFieldValidAllowEmpty(parent.style.paddingBottom)) {
            parent.style.paddingBottom = "0px";
        }

        if (isFieldValidAllowEmpty(parent.style.marginBottom)) {
            parent.style.marginBottom = "0px";
        }

        var children = parent.children;
        if(children && children.length > 0) {
            var lastChildren = children[children.length - 1];
            removeLastElementBottomSpace(lastChildren);
        }
    }
}

/*移除未替换的占位符外层p标签下边距*/
function removeErrorPlaceHolderBottomSpace() {
	try {
	    var paragraphs = document.getElementsByTagName("p");
	    for (var i = 0; i < paragraphs.length; i++) {
	        var paragraph = paragraphs[i];
	        if (paragraph.childNodes.length === 1 && paragraph.childNodes[0].nodeType === Node.COMMENT_NODE) {
	            paragraph.style.paddingBottom = "0px";
	            paragraph.style.marginBottom = "0px";
	        }
	    }
	} catch (e) {
	    console.log("removeErrorPlaceHolderBottomSpace error : " + e);
	}
}

//当视频或图片开头时，调整视频和图片的上边距
function fixTopVideoOrImgTopSpace() {
    var detail_declare = document.getElementById("detail_declare");
    var content = document.getElementById("content");
    var allNodeList = content.childNodes;
    if(allNodeList.length <= 1) {
        return;
    }

    //视频上面有一个空p标签占位，所以需查找两个标签
    for(i=0;i<2;i++) {
        var node = allNodeList[i];
        if(detail_declare.style.display == 'none') {
           //当不展示转载声明时，正文由视频开头，需要调整视频上边距为4px
           if(node.id == "videoContent") {
                node.style.paddingTop = "0px";
                node.style.marginTop = "4px";
                console.log("fixTopVideoOrImgTopSpace:fix top video/img space success with no declare.");
                break;
           }
        } else {
            //当展示转载声明时，正文由视频或图片开头，需要调整上边距为3px
            if(node.id == "videoContent" || node.id == "imgPlaceholder") {
                node.style.paddingTop = "0px";
                node.style.marginTop = "3px";
                console.log("fixTopVideoOrImgTopSpace:fix top video/img space success.");
                break;
            }
        }
    }
    console.log("fixTopVideoOrImgTopSpace");
}


/*房产电话咨询调用*/
function houseCallPhone(tag,telephoneStr){
    ifeng.houseTelephone(tag,"'"+telephoneStr+"'");
}
/*房卡卡片活动跳转调用*/
function toHouseCardDetail(houseLinkUrl){
    ifeng.houseLink(houseLinkUrl);
}
/*房产频道房源卡片相关*/
function buildHouseCard(content){
    var houseCardLPStr = datas.getHouseCardLPJson();
    content = handleHouseContent(content,houselp_p,houseCardLPStr);

    var houseCardFYStr = datas.getHouseCardFYJson();
    content = handleHouseContent(content,housefy_p,houseCardFYStr);

    var houseCardXQStr = datas.getHouseCardXQJson();
    content = handleHouseContent(content,housexq_p,houseCardXQStr);

    var houseCardHDStr = datas.getHouseCardHDJson();
    content = handleHouseContent(content,househd_p,houseCardHDStr);

    var houseCardDCStr = datas.getHouseCardDCJson();
    content = handleHouseContent(content,housedc_p,houseCardDCStr);
    return content;
}
function handleHouseContent(content,flag_p,sourceJson){
    if(sourceJson != null && sourceJson != "null" && sourceJson != "" && sourceJson != 'undefined'&&Object.prototype.toString.call(sourceJson) == '[object String]'){
        var houseCardList = JSON.parse(sourceJson);
        content = handleFlagWithMinLength(content,flag_p,houseCardList.length,
                function(i) {
                    return houseCardList[i].html;
                });
    }
    return content;
}

//初始化文章标题
function initNewsTitle() {
    var newsType = ifeng.getNewsType();
    var title = datas.getTitle();
    if (isFieldValid(title)) {
        document.getElementById('title').textContent = title;
    }
}

//稿源信息
function initSource(datas){
    try{
        var wrapper = document.getElementById('time-and-source-panel');
        wrapper.onclick = function(event) {
            ifeng.gotoSubscribe("");
            event.stopPropagation();
        }
        // 头像布局
        var iconWrap = document.getElementById('cir');
        var icon = document.getElementById('source_icon');
        var iconTag = document.getElementById('source_tag');
        // 自媒体名布局
        var source = document.getElementById('source');
        var catesource = document.getElementById('catesource');
        var line = document.getElementById('verticalline');
        // 原创、时间、简介布局
        var timeLayout = document.getElementById('wrap_time_original');
        var time = document.getElementById('time');
        var time_after_name = document.getElementById('time_after_name');
        var src_infonormal = document.getElementById('src_infro');
        var original_content = document.getElementById('original_content');

        var catesource_str,type,cateName,imgPath,source_tag,declare,srcInfo,originalName;
        // 订阅按钮
        var subButton = document.getElementById('subscribe');
        var detail_declare = document.getElementById('detail_declare');
        if(datas.getSubscribe()){
            catesource_str = datas.getSubscribe().getCateSourceForJs();
            type = datas.getSubscribe().getType();
            cateName = datas.getSubscribe().getCatename();
            imgPath = datas.getSubscribe().getLogo();
            originalName = datas.getSubscribe().getOriginalName();

            if (ifeng.isNightMode()) {
                source_tag = datas.getSubscribe().getHonorImgNight();
            } else {
                source_tag = datas.getSubscribe().getHonorImg();
            }

            declare = datas.getSubscribe().getDeclare();
            srcInfo = datas.getSubscribe().getDescription();
        }

        var newsType = ifeng.getNewsType();

        // 大风号标签
        if(catesource_str && typeof(catesource_str)!="undefined" && catesource_str!=null && catesource_str!=""){
            catesource.style.display = "block";
            line.style.display = "block";

            catesource.textContent = catesource_str;
        }else{
            catesource.style.display = "none";
            line.style.display = "none";
        }

        // 时间
        if (datas.getUpdateTimeForDetail() != null && datas.getUpdateTimeForDetail() != "") {
            time.textContent = datas.getUpdateTimeForDetail();
            if (ifeng.isDailyNews()) {
                time_after_name.textContent = datas.getUpdateTimeForDetail();
                time_after_name.style.display = "block";
            } else {
                time_after_name.style.display = "none";
            }
        } else {
            time.style.display = "none";
            time_after_name.style.display = "none";
        }

		// 自媒体名
		if (typeof(cateName) != "undefined") {

		    if (time_after_name.style.display === 'none' || !ifeng.isDailyNews()) {
		        source.textContent = cateName;
		    } else {
		        setHtmlByJQuery(source, '<strong>' + cateName + " ·" + '</strong>');
		    }

		} else {
		    source.style.display = "none";
		}

        //原创标签
        if (typeof(originalName)!="undefined" && originalName != null && originalName != "") {
              if (original_content != null) {
                   original_content.style.display="block";
                   original_content.textContent = originalName;
              }
        } else{
              if (original_content != null) {
                    original_content.style.display="none";
              }
              time.style.marginLeft = 0;
        }

        if(typeof(type)!="undefined"){
            Ground.isSubscribe(subSourceSuccessForDoc(),"");
            // 自媒体简介
            if (src_infonormal != null) {
                if (typeof(srcInfo) != "undefined" && srcInfo != null && srcInfo != "") {
                    src_infonormal.textContent = srcInfo;
                    if (original_content.style.display == "none" && time.style.display == "none") {
                        src_infonormal.style.marginLeft = 0;
                    }
                } else {
                    src_infonormal.style.display="none";
                }
            }
        }else{
            subButton.style.display = "none";
        }

        // 隐藏时间父布局
        var isTimeLayoutDisplayNone =  original_content.style.display == "none"
                            && time.style.display == "none"
                            && src_infonormal.style.display == "none";;
        if (isTimeLayoutDisplayNone) {
            timeLayout.style.display="none";
        }

        // 设置自媒体头像
        if(typeof(imgPath)!="undefined" && imgPath!=0){
            icon.style.display = 'block';
            Ground.loadUserHeadImageDirectly(imgPath, null,
                loadImageSuccessInterceptor(icon),
                loadSubscriptImageFailInterceptor(icon,imgPath), 'forceLoad');
        }
        // 去掉用自媒体名首字作为logo
//        else if(cateName && typeof(cateName)!="undefined"){
//            icon.style.display = 'block';
//            Ground.loadImageDirectly(cateName, null,
//                loadImageSuccessInterceptor(icon),
//                loadSubscriptImageFailInterceptor(icon,cateName), 'forceLoad');
//        }
        else{
            iconWrap.style.display = "none";
            icon.style.display = "none";
        }

        // 荣誉认证V
        if(source_tag && typeof(source_tag)!="undefined" && source_tag!=null && source_tag!=""&&source_tag != 0){
            iconTag.style.display = "block";
            Ground.loadImageDirectly(source_tag, null,
                loadImageSuccessInterceptor(iconTag),
                loadSubscriptImageFailInterceptor(iconTag,source_tag), 'forceLoad');
        }

        subButton.onclick = function(event) {
            Ground.addSubscribe(subSourceSuccessForDoc(),"");
            event.stopPropagation();
        };

        if(datas.getSubscribe()!= null && datas.getSubscribe().getForbidFollow()=='1'){
            subButton.style.display = "none";
        }

        var feedback = document.getElementById('feedback');
        if(ifeng.fromPush()){
            subButton.style.display = "none";
            feedback.textContent = '推送反馈';
            feedback.style.display = "block";
            feedback.onclick = function(event){
                ifeng.toastFeedBack(window.devicePixelRatio*(getTop(feedback)));
                event.stopPropagation();
            };
        }

        if(typeof(declare)!="undefined" && declare!=0) {
            detail_declare.style.display = "block";
            detail_declare.textContent = declare;
            document.getElementById('content').style.paddingTop = "0px";
        }

        //早晚报特殊样式
		if (ifeng.isDailyNews()) {

		    time.style.display = "none";

		    var divElements = timeLayout.getElementsByTagName('div');
		    for (var i = 0; i < divElements.length; i++) {
		        divElements[i].classList.add('color_757575_84848A');
		        divElements[i].classList.add('font_size_12');
		    }

		    if (original_content.style.display === 'none') {
		        src_infonormal.style.marginLeft = '0';
		    }
		}

    }catch(e){
        console.log("error:"+e);
    }
}



/*正文 切换订阅按钮状态*/
function subSourceSuccessForDoc() {
	return function(subState) {
		var subButton = document.getElementById('subscribe');
		var subText = document.getElementById('subscribe_viewpoint');

		var isNightMode = ifeng.isNightMode();
		if (subState) {
			var delSubImg = "followed_day.png";
			if (isNightMode) {
				delSubImg = "followed_night.png";
			}
			subButton.setAttribute("src", delSubImg);
			var subId = datas.getSubscribe().getFollowId();
			var viewSubId = datas.getViewPointSubscribe().getFollowId();
			if (subId == viewSubId) {
				subText.style.color = "#9E9E9E";
				subText.textContent = "已订阅";
			}

		} else {
			var addSubImg = "follow_day.png";
			if (isNightMode) {
				addSubImg = "follow_night.png";
			}
			subButton.setAttribute("src", addSubImg);
			if (subId == viewSubId) {
				subText.style.color = "#F54343";
				subText.textContent = "订阅";

			}

		}
		console.log("subSourceSuccessForDoc");
	};
}



function getWebViewSelectedData(title){
    var value = "";
    if(window.getSelection){
        value = window.getSelection().toString();
    }else if(window.document.getSelection){
        value = window.document.getSelection().toString();
    }else if(window.document.selection){
        value = window.document.selection.createRange.text;
    }
    ifeng.getSelectedText(title,value);
}

function docSelectAll(title){
    var doc = document,
          text = doc.getElementById('ifeng-article'),
          range,
          selection;

      if (doc.body.createTextRange) {
          range = document.body.createTextRange();
          range.moveToElementText(text);
          range.select();
      } else if (window.getSelection) {
          selection = window.getSelection();
          selection.removeAllRanges();

          range = document.createRange();
          range.selectNodeContents(text);
          selection.addRange(range);
      }
      getWebViewSelectedData(title);
}

function isFieldValid(field){
    if(field != null && field != "" && field != 'undefined' && field != undefined ){
        return true
    }
    return false
}

function isFieldValidAllowEmpty(field){
    return "" == field || isFieldValid(field);
}


//初始化文章简介
function initSummary(summaryStr) {
    var summaryParent = document.getElementById('summary_parent');
    var summaryContent = document.getElementById('summary');
    if (summaryStr.length > 0) {
        summaryParent.style.display = 'inline-block';
        summaryContent.textContent = summaryStr;
    } else {
        summaryParent.style.display = 'none';
    }

}

// 发送日志
function sendWebLog(type, msg, e) {
    var docId = datas.getDocumentId() || 'null doc id',
        eMsg = e && e.message ? e.message : 'null error msg';

    ifeng.webLog(docId + '---' + type + '---' + eMsg + '---' + msg);
}

function dealWithIfengDocAdPlaceHolder(content){
    var ifengDocAdListStr = datas.getIfengDocAdListJson();
    if(ifengDocAdListStr && Object.prototype.toString.call(ifengDocAdListStr) == '[object String]'){

        var ifengDocAdList = JSON.parse(ifengDocAdListStr);
        content = handleFlagWithMinLength(content,ifeng_doc_ad_p,ifengDocAdList.length,
            function(i) {
                return '<div class="ifeng_doc_ad_classes" id="ifeng_doc_ad_content_'+i+'" style="width:100%;height=%.0fpx;margin-top:20px;margin-bottom:20px; "></div>';
            });
    }
    return content;
}

/**
  *获取ifeng_doc_ad的所有div
*/
function getIfengDocAdContentDives() {
    var ifengdocAd_classes = document.getElementsByClassName("ifeng_doc_ad_classes");
    if (!ifengdocAd_classes || ifengdocAd_classes.length <= 0) {
        return null;
    }
    return ifengdocAd_classes;
}

/**
  * 开始处理ifeng_doc_ad广告的原生view添加到div占位处
  * currentIndex是div数组里的下标，如果有删除currentIndex还是div数组里的下标。
  * position是原生缓存的view数组的下标。没有删除时二者一致
*/
function renderIfengDocAdContentView(currentIndex) {
    if(currentIndex == 0) {
        var divs = getIfengDocAdContentDives();
        if (divs == null) {
            ifeng.resumeRenderPlaceHolderViews();
            return;
        }
    }

    removeNotePreEmptyPBottomSpace("ifeng_doc_ad_classes");

    var divs = getIfengDocAdContentDives();
    if (divs == null || currentIndex > divs.length - 1) {
        ifeng.resumeRenderPlaceHolderViews();
        return;
    }
    var bigImgDiv = divs[currentIndex];
    var id = bigImgDiv.getAttribute("id");
    var top = window.devicePixelRatio * getTop(bigImgDiv);
    var divId = id.replace("ifeng_doc_ad_content_","");
    var position = parseInt(id.slice(-1));
    console.log('renderIfengDocAdContentView, position=' + position + ' id=' + id + ' top=' + top);
    ifeng.addIfengDocAdViewToWebView(top, id, position, currentIndex);
    ifeng.setIfengDocAdPosition(offsetTop(bigImgDiv),position);
}

/**
  * 删除ifeng_doc_ad的div
 */
function deleteIfengDocAdContentView(position) {
    var divId = "ifeng_doc_ad_content_"+position;
    var bigImgDiv = document.getElementById(divId);
    if(bigImgDiv != null && bigImgDiv != undefined){
        // 获取删除div所占的高度，用来同步更新native views
        var bigImgDivHight = window.devicePixelRatio * (bigImgDiv.offsetHeight + 40);
        // 操作的div的Y，更新时只处理这之下的view上移
        var divY = window.devicePixelRatio * (getTop(bigImgDiv));
        console.log('deleteIfengDocAdContentView, divId='+divId);
        bigImgDiv.parentNode.removeChild(bigImgDiv);

        // 延迟处理是需要等dom更新后,否则会错乱
        setTimeout(function(){
           //调用原生方法处理当前div下面的所有view，上移指定的高度
           ifeng.updateChildrenOffset(divY,-bigImgDivHight);
        }, 200);
    } else {
       console.log('deleteIfengDocAdContentView, has no ifeng doc ad for position='+position);
    }
}

function changeIfengDocAdDivHeight(height,divId){
    if(!divId) {
        return;
    }

    var ifengDocAdDiv = document.getElementById(divId);
    if(ifengDocAdDiv != null && ifengDocAdDiv != undefined){
      ifengDocAdDiv.style.height = height + "px";
      console.log('changeIfengDocAdDivHeight, height='+height+' divId=' + divId);
    }
}

function dealWithSurveyPlaceHolder(content){
    var surveyListStr = datas.getSurveylistJson();
    if(surveyListStr&&Object.prototype.toString.call(surveyListStr) == '[object String]'){

        var surveyList = JSON.parse(surveyListStr);
        content = handleFlagWithMinLength(content,survey_p,surveyList.length,
            function(i) {
                return '<div class="survey_classes" id="survey_content_'+i+'" style="width:100%"></div>';
            });
    }
    return content;
}

function renderSurveyContentView(position) {
    var survey_classes = document.getElementsByClassName("survey_classes");
    if(!survey_classes || survey_classes.length <= 0) {
        ifeng.resumeRenderPlaceHolderViews();
        return;
    }
    removeNotePreEmptyPBottomSpace("survey_classes");

    var id = "survey_content_"+position;
    var surveyDiv = document.getElementById(id);
    if(surveyDiv != null && surveyDiv != undefined){
       var top = window.devicePixelRatio*getTop(surveyDiv);
       var left = window.devicePixelRatio * getLeft(surveyDiv);
       console.log('dealWithSurvey, position='+position+' id=' + id+' top=' + top+' left=' + left);

       ifeng.addSurveyViewToWebView(top,id,position,left);
    } else {
       console.log('dealWithSurvey, has no survey for position='+position);
    }
}

function changeDivHeight(height,divId){
    if(!divId) {
        return;
    }

    var div = document.getElementById(divId);
    if(div != null && div != undefined){
      div.style.height = height + "px";
    }
}

/**
 * 格式化图片处理，包括：
 *     1. p标签内套多个img
 *     2. p标签内有small标签
 *     3. 一个p标签内图文混排
 *     4. 图片不在任何p标签内
 */
function formatText(text) {

    var fragment = document.createElement('div');
    setHtmlByJQuery(fragment, text);
    var eles = Array.prototype.slice.call(fragment.getElementsByTagName('p'));
    for (var i = 0; i < eles.length; i++) {
         var container = eles[i];
         if(container.getElementsByTagName('small').length === 1) {
            container.className += ' img-note';
         }
         imgs = Array.prototype.slice.call(container.getElementsByTagName('ifengimg'));
         if (imgs.length < 2) {
                     continue;
         }
         for ( var j = 0; j < imgs.length; j++) {
              var img = imgs[j];
              if(img.parentNode.nodeName == 'P'){
                var p = document.createElement('p');
                p.appendChild(img.cloneNode(false));
                img.parentNode.replaceChild(p,img);
              }
         }
    }
    var imgs = Array.prototype.slice.call(fragment.getElementsByTagName('ifengimg'));
    for (var j = 0; j < imgs.length; j++) {
         var img = imgs[j];
         if (img.parentNode.nodeName != 'P' || img.parentNode.innerText != '') {
             var newp = document.createElement('p');
             if (img.parentNode.nodeName == 'A') {
                var parent = img.parentNode;
                var temp_parent = parent.cloneNode(true);
                newp.appendChild(temp_parent);
                parent.parentNode.replaceChild(newp, parent);
             } else {
                var temp_img = img.cloneNode(false);
                newp.appendChild(temp_img);
                img.parentNode.replaceChild(newp, img);
             }
         }
    }
    return getHtmlByJQuery(fragment);
}

/**
 * 处理正文中 文字 部分的<a>标签
 *   注意：图片外层的 <a> 在 processImage 里处理
 */
function dealwithTextAtag (container) {
    var all_a = Array.prototype.slice.call(container.getElementsByTagName('a'));
        for ( var i = 0; i < all_a.length; i++) {
             var tempA = all_a[i];
             var ifenghref = tempA.getAttribute("ifengapp-data");
             var tempHref = tempA.getAttribute("href");
             if (ifenghref != null) {
                 tempA.setAttribute("href", "javascript:void(0);");
                 tempA.onclick = function() {
                   ifeng.popupLightbox(null, -1, this.getAttribute("ifengapp-data"));
                 };
             } else if (tempHref != null) {
                 //如果这个A标签本身是调用一个js方法，则这个A标签不做处理
                 if(tempHref.startsWith("javascript")){
                    continue;
                 }

                 var type = tempA.getAttribute("type");
                 ifenghref = ifeng.getIfengHrefByHrefAndType(tempHref,type);
                 tempA.setAttribute("ifengapp-data", ifenghref);
                 tempA.setAttribute("href", "javascript:void(0);");
                 tempA.onclick = function() {
                   ifeng.popupLightbox(null, -1, this.getAttribute("ifengapp-data"));
                 };
             }
        }
}

function renderCardAd(i){
     var container = document.getElementById('content');
     var cardadComponent = container.getElementsByClassName('cardad');
     if(i >= cardadComponent.length) {
         ifeng.resumeRenderPlaceHolderViews();
         return;
     }

     var cardadDom = cardadComponent[i];
     ifeng.initCardAdLayout(window.devicePixelRatio*(getTop(cardadDom)),i);
     ifeng.setCardAdPosition(offsetTop(cardadDom),i);
}

//在正文和作者简介中间插入banner
function renderTopBanner(){
    var bannerType = datas.getTopbannerType();
    var hasBannerImg = datas.getTopbannerImg();
    var banner = document.getElementById('doc_banner');
    var bannerWrap=document.getElementById('doc_banner_wrap');
    if(bannerType != null && bannerType != "null" && bannerType != undefined && bannerType != ""){
        bannerWrap.style.display = "block";
        banner.style.display = "block";
        //精品深度，专题，热点，话题（高度不一致）
        if(bannerType == "qualityReadingList"){
            if(hasBannerImg){
                banner.style.height = "44px";
            }else{
                bannerWrap.style.display = "none";
                banner.style.display = "none";
            }
        }else{
            if(hasBannerImg){
              banner.style.height = "104px";
            }else{
              banner.style.height = "58px";
            }
        }
        ifeng.setDocInnerTopBanner(window.devicePixelRatio*banner.clientWidth,window.devicePixelRatio*banner.clientHeight,window.devicePixelRatio*getLeft(banner), window.devicePixelRatio*getTop(banner),bannerType);
    }else{
        banner.style.display = "none";
        bannerWrap.style.display = "none";
        ifeng.resumeRenderPlaceHolderViews();
    }
}

// 设置正文字体
function setFontSize(fs,titleFontSize,contentFontSize,summaryFontSize,refreshPlaceholders) {
    var tdom = document.getElementById('title');
    var declareDom = document.getElementById('detail_declare');
    var cdom = document.getElementById('content');
    var summaryParentDom = document.getElementById('summary_parent');
    var summaryDom = document.getElementById('summary');
    var unfoldDom = document.getElementById('unfold_bottom-space');
    if(fs){
    	if(FIRSTFONT){
    		var offset = FONTS[fs] - FONTS[FIRSTFONT];
       		var spans = document.getElementsByName('content_span');
   			for(var i=0; i<spans.length; i++){
    			var spanClass = spans[i].getAttribute('class');
    			for(var font in FONTS){
    				if(FONTS[font] == FONTS[spanClass]+offset){
    					spans[i].setAttribute('class', font);
    				}
    			}
    		}
		}
		FIRSTFONT = fs;
        cdom.className = 'content ' + fs;
        tdom.className = 'title '+ fs;
        declareDom.className = 'detail_declare detail_declare_color '+ fs;
        summaryParentDom.className = 'summary_parent '+ fs;
        summaryDom.className = 'summary '+ fs;
        unfoldDom.className = 'unfold_bottom-space '+ fs;

        cdom.style.fontSize  = contentFontSize +'px'
        tdom.style.fontSize  = titleFontSize +'px'
        summaryDom.style.fontSize  = summaryFontSize +'px'

		if (refreshPlaceholders) {
            ifeng.startRenderPlaceHolderViews();
		}
    }
}


//初始化自媒体免责声明
function initClaimer(disclaimer, originalLink) {
    var success = false;
    if (disclaimer
        && Object.prototype.toString.call(disclaimer) === '[object String]') {
        document.getElementById("disclaimer").innerText = disclaimer;
        success = true;
    }
    if(originalLink
        && Object.prototype.toString.call(originalLink) === '[object String]') {
        success = true;
        var originBtn  = document.getElementById("originBtn");
        originBtn.innerText = "阅读原文";
        originBtn.onclick = function() {
            ifeng.jump('webfull', originalLink,"","disclaimer");
        };
    } else {
        document.getElementById("originBtn").style.display = "none";
        if(success) {document.getElementById("disclaimer").marginBottom = "0px";}
    }
    if(success) {
        if(topFlag == 0) {
            document.getElementById('ifeng-article').style.paddingBottom = "0px";
        }
        document.getElementById("disclamer_wrapper").style.display = "block";
    }
}


/**
  *  客户端正文内的热词标签点击跳转.
  *
  */
function addIWordsClickLister(container){

     var classArrs = container.getElementsByClassName(class_iwords);
     if(classArrs != null && classArrs.length > 0){

         for(var i = 0; i < classArrs.length; i ++){
             if(classArrs[i] != null && classArrs[i] != undefined){
                 classArrs[i].onclick = function(){
                      ifeng.goToSearch(this.innerText);
                 };
             }
         }
     }
}

// 设置图注字体
function setPicIntroFontSize(fs,picIntroFontSize) {
    var picIntroDom = document.getElementsByClassName("picIntro");
    if(fs){
        for (var i =0;i < picIntroDom.length;i ++) {
            picIntroDom[i].className = 'picIntro ' + fs;
        }

    }
}

//下载图片
function loadListImages(docs, srcName) {
    var imgs = docs.getElementsByTagName('img');
    for (var i = 0; i < imgs.length; i++) {
        var imageDom = imgs[i],
            imageSrc = imageDom.getAttribute(srcName);
        if (imageSrc) {
            Ground.loadImageDirectly(imageSrc, null,
                loadImageSuccessInterceptor(imageDom, i),
                loadImageFailInterceptor(imageDom, imageDom.getAttribute(srcName)), 'false');
        }
    }
}

function offsetTop(elements) {
    var top = elements.offsetTop;
    var parent = elements.offsetParent;
    while (parent != null) {
        top += parent.offsetTop;
        parent = parent.offsetParent;
    };
    return top;
};

//作者和责任编辑
function initEditorCode(author,editorCode) {

	var editor = document.getElementById('editor');
	if((!author||author.length<1)&&(!editorCode || editorCode.length < 1)) {
		editor.style.display = 'none';
		document.getElementById('editor_div').style.display = 'none';
		return false;
	}
	var container = document.getElementById('ifeng-article');
	container.style.paddingBottom = '0px';
	var authorText = '';
	if(author&&author.length>1){
		 authorText = '作者: '+author;
	}

	var editorCodeText = '';
	if(editorCode || editorCode.length > 1){
		editorCodeText = '责任编辑: '+editorCode;
	}
	editor.style.display = 'inline';
	if(authorText && authorText.length>1){
        editor.textContent =authorText+' '+editorCodeText;
    }else{
        editor.textContent =editorCodeText;
    }
	topFlag = 1;
	document.getElementById('insert-news').style.paddingBottom = "0px";
}

//得到图集的宽和高 如果有宽和高的话，需要重新设置min-height为返回的高
function getSlideItemHeight(thumbnailSize) {
	var minHeight = '';
	if(thumbnailSize) {
        var width = thumbnailSize.width, height = thumbnailSize.height;
    	if (width && height) {
    		minHeight = 'min-height:'+IMAGE_PLACEHOLDER_HEIGHT+'px';
    	}
    }
	return minHeight;
}

function getCenterAdHeightRule(item){
    var extraRule = '';
        if(item.imageWidth && item.imageHeight) {
            var width = item.imageWidth, height = item.imageHeight;
            if (width && height) {
                var minheight = 'min-height:'+cropper.getResult(width, height).height+'px';
                extraRule = 'style="'+minheight+'"';
            }
        }
        return extraRule;
}

function getVideoRule() {
	return 'style="min-height:'+IMAGE_PLACEHOLDER_WIDTH*VIDEO_SLOP+'px"';
}

function getContentPosition(content,str) {
	var index=0,list = [];
	while((index=content.indexOf(str,index))!=-1) {
		list.push(index++);
	}
	return list;
}

function insertStr(source,str,position) {
	var str_sta = source.substring(0, position);
	var str_end = source.substring(position);
	return str_sta+str+str_end;
}

//处理正文中图片
function processImage(cropper, default_height, content, container) {
    var loadMessage = getLoadingImage();

    //建立一个div装载html代码
    var fragment = document.createElement('div');
    setHtmlByJQuery(fragment, content);

    //获取所有图片标签(img标签在DocBody的formatText方法中替换成了ifengimg标签)
    var imgEls = Array.prototype.slice.call(fragment.getElementsByTagName('ifengimg'));

    try {
        //遍历所有图片标签
        for (var i = 0; i < imgEls.length; i++) {
            var img = imgEls[i];
            var parent = img.parentNode;
            var placeholder = document.createElement('div');

            //处理图片外层的 <a> 标签
            if (parent.nodeName == 'A') {
                var ifenghref = parent.getAttribute("ifengapp-data");
                var tempHref = parent.getAttribute("href");
                if (ifenghref != null) {
                    placeholder.setAttribute("jumpUrl", parent.getAttribute("ifengapp-data"));
                } else if (tempHref != null) {
                    var type = parent.getAttribute("type");
                    ifenghref = ifeng.getIfengHrefByHrefAndType(tempHref,type);
                    placeholder.setAttribute("jumpUrl", ifenghref);
                }
                parent.parentNode.replaceChild(img, parent);
                parent = img.parentNode;
            }

            var imgUrl = img.getAttribute('src');
            if (!imgUrl) {
                continue;
            }
//            console.log('img src = ' + imgUrl);

            var image_height = '';
            placeholder.id = 'imgPlaceholder';
            placeholder.className = 'placeholder ' + datas.getFontSize();
            placeholder.setAttribute('src', imgUrl);
            placeholder.setAttribute('index', i + image_index);
            placeholder.setAttribute('loadState', 'loading');
            placeholder.setAttribute('placeholder_tag', 'tag');
            placeholder.setAttribute('background', '#ff00ff');
            //用于点击查看图片切换
            srcs.push(img.getAttribute('src'));

            var setwidth = false;
            var image_width;
                var reg = new RegExp("_w(\\d+)_h(\\d+)", "g");
                var result = null,
                    next_result;

                while ((next_result = reg.exec(imgUrl)) != null) {
                    result = next_result;
                };
                var w = 0,
                    h = 0;
                if (result && result.length == 3) {
                    w = result[1];
                    h = result[2];
                }
                if (w < SCREEN_WIDTH * 0.7 && h) {
                    setwidth = true;
                    image_width = w + 'px';
                    image_height = h + 'px';
                } else {
                    if (w && h) {
                        result = cropper.getResult(w, h);
                        if (result.height == 0) {
                            image_height = default_height + 'px';
                        } else {
                            image_height = result.height + 'px';
                        }
                    } else {
                        // 如果没有获取到高，就用默认高
                        image_height = default_height + 'px';
                    }
                }
            if (setwidth) {
                placeholder.style.width = image_width;
            }
            placeholder.style.height = placeholder.style.minHeight = image_height;
            console.log("processImage image_height : "+image_height + ",url="+imgUrl);

            setHtmlByJQuery(placeholder, loadMessage);
            parent.parentNode.replaceChild(placeholder, parent);

        }
        image_index += imgEls.length;
    } catch (e) {
        sendWebLog('text img error', datas.getTransFormText());
        console.log("processImage error : "+e);
    }
    return getHtmlByJQuery(fragment);
}

// 处理所有占位符（不依赖数据）
function handleFlagWithoutData(content, flag_p, getItem) {
    return handleFlagWithMinLength(content, flag_p, -1, getItem);
}

// 根据数据处理占位符，若数据与占位符数量不匹配，则按最小的数量进行加载
function handleFlagWithMinLength(content, flag_p, itemDataLength, getItem) {
    //获取所有占位符的索引列表
    var list = getContentPosition(content, flag_p);
    //占位符个数
    var length = list.length;
    //占位符文字的长度
    var flag_p_length = flag_p.length;

    if (length <= 0) {
        return content;
    }

    var i, j, temp_sum;
    var showCount = length;
    if (itemDataLength > -1) {
        showCount = Math.min(length, itemDataLength);
    }

    //移除所有占位符
    content = content.replace(new RegExp(flag_p, "gm"), "");

    //校正移除占位符后的索引位置
    for (i = 0; i < length; i++) {
        list[i] -= flag_p_length * i;
    }

    for (j = 0, temp_sum = 0; j < showCount; j++) {

        //获取getItem方法内定义的字符串
        var item_str = getItem(j);
        if (!item_str || Object.prototype.toString.call(item_str) !== '[object String]') {
            continue;
        }

        //将该字符串插入正文 每次插入需要处理之前的插入对本次插入产生的索引偏移 temp_sum
        content = insertStr(content, item_str, temp_sum + list[j]);
        temp_sum += item_str.length;
    }
    return content;
}

// 根据数据处理占位符，若数据与占位符数量不匹配，则按最大的数量进行加载
// 匹配不到占位符的数据，直接追加到末尾
function handleFlagWithMaxLength(content, flag_p, item_length, getItem) {
    var list = getContentPosition(content, flag_p);
    var length = list.length;
    var flag_p_length = flag_p.length;

    if (length > 0) {
        var i, j, temp_sum, min_length = Math.min(length, item_length);
        content = content.replace(new RegExp(flag_p, "gm"), "");
        for (i = 0; i < length; i++) {
            list[i] -= flag_p_length * i;
        }
        for (j = 0, temp_sum = 0; j < min_length; j++) {
            var item_str = getItem(j);
            if (!item_str || Object.prototype.toString.call(item_str) !== '[object String]') {
                continue;
            }
            content = insertStr(content, item_str, temp_sum + list[j]);
            temp_sum += item_str.length;
        }
        if (length < item_length) {
            for (i = item_length - 1; i >= j; i--) {
                var item_str = getItem(i);
                if (!item_str || Object.prototype.toString.call(item_str) !== '[object String]') {
                    continue;
                }
                content = item_str + content;
            }
        }
    } else {
        for (var i = item_length - 1; i > -1; i--) {
            var item_str = getItem(i);
            if (!item_str || Object.prototype.toString.call(item_str) !== '[object String]') {
                continue;
            }
            content = item_str + content;
        }
    }
    return content;
}

// 显示正文 处理图片显示底图 准备加载
function preprocessImage(content, container, shortDocRelateFontSize) {
    var loadMessage = getLoadingImage();

    //处理正文文本区域内的图片占位
    content = processImage(cropper, IMAGE_PLACEHOLDER_HEIGHT, content, container);

    // 显示中心广告
    var advertData = datas.getArticleAdDataJson();
    if (advertData && Object.prototype.toString.call(advertData) == '[object String]') {
        var adBean = JSON.parse(advertData);
        content = handleFlagWithoutData(content, center_ad_p,
            function(i) {
                if (adBean.type == 'advert') {
                    var str = '<div class = "advertdiv" id="advertdiv""></div>';
                    if (adBean.link.url) {

                        str = '<div class = "advertdiv" id = "advertdiv" style="position:relative;display:block;padding-left:60px;"' + getCenterAdHeightRule(adBean) + '><img id="advert" style="position:relative;width:100%;" class="advert" ' + ' advertsrc="' + adBean.thumbnail + '" src="' + adBean.link.url + '"/>';
                    } else {
                        return str;
                    }

                    var addTagHtml = '';
                    if(ifeng.isNightMode()) {
                        addTagHtml = '<img id="ad-close" src="ad_detail_close_night.png" ' + 'style="position:absolute;width:24px;height:24px;top:5px;right:7px;z-index:100"/>' + '<div id="ad_tag" class="adv-tag">&nbsp;广告&nbsp;</div></div>';
                    } else {
                        addTagHtml = '<img id="ad-close" src="ad_detail_clolse.png" ' + 'style="position:absolute;width:24px;height:24px;top:5px;right:7px;z-index:100"/>' + '<div id="ad_tag" class="adv-tag">&nbsp;广告&nbsp;</div></div>';
                    }
                    return str + addTagHtml;
                }
                return null;
            });
    } else {
        content = handleFlagWithoutData(content, center_ad_p,
            function(i) {
                return '<div class = "advertdiv" id="advertdiv""></div>';
            });
    }

    // 显示slide封面
    var slideJson = datas.getExtSlidesJson();
    if (slideJson && Object.prototype.toString.call(slideJson) == '[object String]') {
        var slideList = JSON.parse(slideJson);
        content = handleFlagWithMaxLength(content, slide_p, slideList.length,
            function(i) {
                var slideItem = slideList[i]
                if (slideItem.type == 'slide') {
                    if (slideItem.title) {
                        return '<p style="margin-top:26px;margin-bottom:11px; ' + getSlideItemHeight(slideItem.thumbnailSize) + ' " class="slide" ' + ' slidesrc="' + slideItem.thumbnailpic + '" src="' + slideItem.url + '">' + loadMessage + '</p><div><small class="slide-small" style="line-height:23px;">' + slideItem.title + '</small></div>';
                    } else {
                        return '<p style="margin-top:26px;margin-bottom:26px; ' + getSlideItemHeight(slideItem.thumbnailSize) + '" class="slide" ' + ' slidesrc="' + slideItem.thumbnailpic + '" src="' + slideItem.url + '">' + loadMessage + '</p>';
                    }
                }
                return null;
            });
    }


    // 显示video封面
    var videoData = datas.getVideoJson();
    if (videoData && Object.prototype.toString.call(videoData) == '[object String]') {
        var videos = JSON.parse(videoData);
        content = handleFlagWithMaxLength(content, video_p, videos.length,
            function(i) {
                var videoItemContent = "";
                var videoTitle = videos[i].title;
                if (!videoTitle || videoTitle == "undefined") {
                    videoTitle = "";
                }
                videoItemContent += '<div id="videoContent" class="video video_bg_color" ' + getVideoRule(videos[i]) +
                    '" videoType=normal imgsrc="' + videos[i].thumbnail +
                    '" normalSrc="' + videos[i].video.Normal.src +
                    '" normalSize="' + videos[i].video.Normal.fileSize +
                    '" HDSrc="' + videos[i].video.HD.src +
                    '" HDSize="' + videos[i].video.HD.fileSize +
                    '" duration="' + videos[i].duration +
                    '" guid="' + videos[i].guid +
                    '" staticId="' + videos[i].staticId +
                    '" columnId="' + videos[i].columnId +
                    '" title="' + videoTitle +
                    '" thumbnail="' + videos[i].thumbnail +
                    '">' + loadMessage + '</div>';
                return videoItemContent;
            });
    }

    //加载音频
    var audioListStr = datas.getAudioJson();
    if (audioListStr && Object.prototype.toString.call(audioListStr) == '[object String]') {
        var audioList = JSON.parse(audioListStr);
        console.info('audioList' + audioList);
        content = handleFlagWithMinLength(content, audio_p, audioList.length,
            function(i) {
                var staticId = audioList[i].staticId
                if(staticId == "null" || staticId == 'undefined'){
                    staticId = ""
                }
                var audioItemContent =
                    '<div class="audio" id="audio" title="' + audioList[i].title
                        + '" desc="' + audioList[i].audioAppDesc
                        + '" thumbnail="' + audioList[i].thumbnail
                        + '" duration="' + audioList[i].duration
                        + '" srcNor="' + audioList[i].audio.Normal.src
                        + '" srcHD="' + audioList[i].audio.HD.src
                        + '" guid="' + audioList[i].guid
                        + '" staticId="' + staticId
                        + '" columnId="' + audioList[i].columnId
                        + '">' +
                        '<img src="detail_audio_play.png" class="audio_img" />' +
                        '<div class="audio_info" id="audio_info">' +
                            '<div class="audio_title" id="audio_title">' + audioList[i].title + '</div>' +
                            '<div class="audio_desc" id="audio_desc">' + audioList[i].audioAppDesc + '</div>' +
                        '</div>' +
                        '<div class="audio_time" id="audio_time">' + audioList[i].duration + '</div>' +
                        '<div style="clear:both"></div>' +
                    '</div>';
                return audioItemContent;
            });
    }

    //加载卡片广告
    var cardAdListStr = datas.getCardAdJson();
    if (cardAdListStr && Object.prototype.toString.call(cardAdListStr) == '[object String]') {
        var cardAdList = JSON.parse(cardAdListStr);
        console.info('cardAdList' + cardAdList);
        content = handleFlagWithMinLength(content, card_ad_p, cardAdList.length,
            function(i) {
                var cardAdItemContent = '<div class="cardad" ></div>';
                return cardAdItemContent;
            });
    }

    // 核心提示
    var tip = datas.getIntroduction();
    if (tip && Object.prototype.toString.call(tip) == '[object String]') {
        var fragment = document.createElement('div');
        setHtmlByJQuery(fragment, content);
        var childs = fragment.childNodes;
        if (childs && childs.length > 0) {
            var tipContent = "";
            if (childs[0].className == "video_parent" || childs[0].className == "slide" || childs[0].className == "placeholder") {
                tipContent = '<div class="tip-news-wrapper">' + tip + '</div>';
            } else {
                tipContent = '<div class="tip-news-wrapper-se">' + tip + '</div><div class="tip-divider-wrapper"><div class="tip-divider">&nbsp;</div></div>';
            }
            content = tipContent + content;
        }
    } else {
        document.getElementById("time-and-source-panel").style.marginBottom = "10px";
    }

    //调查
    content = dealWithSurveyPlaceHolder(content);

    //文章内部广告带负反馈
    content = dealWithIfengDocAdPlaceHolder(content)

    /*加载房产样式，加载房产卡片内容*/
    var cardStyle = datas.getHouseCardStyle();
    if (cardStyle != null && cardStyle != "null" && cardStyle != "" && cardStyle != 'undefined' && Object.prototype.toString.call(cardStyle) == '[object String]') {
        content = insertStr(content, cardStyle, 0);
    }
    content = buildHouseCard(content);

    // 显示正文
    setHtmlByJQuery(container, content);

    fixDailyNewsImgHeight();

    var eles = Array.prototype.slice.call(container.getElementsByTagName('p'));
    if (eles.length == 0) {
        setHtmlByJQuery(container, '<p>' + getHtmlByJQuery(container) + '</p>');
    }

    // 隐藏loading,可以视情况延时调用
    if (!SCREEN_WIDTH) {
        SCREEN_WIDTH = '0';
    }
    ifeng.hideLoadingMask(SCREEN_WIDTH);
    addIWordsClickLister(container);
    // 启动加载图片
    if(isFieldValid(loadImagesTaskId)) {
        clearTimeout(loadImagesTaskId);
    }
    loadImagesTaskId = setTimeout(loadImages, 200);
}

//获取元素的纵坐标（相对于窗口）
function getTop(e) {
        var offset = e.offsetTop;
        if (e.offsetParent != null) offset += getTop(e.offsetParent);
        return offset;
    }
    //获取元素的横坐标（相对于窗口）

function getLeft(e) {
    var offset = e.offsetLeft;
    if (e.offsetParent != null) offset += getLeft(e.offsetParent);
    return offset;
}

function matchImageUrl(imgUrl) {
    var regx = "/[\/_]w(\d{1,4})_h(\d{1,4})/i";
    var rs = regx.exec(imgUrl);
    var rs1 = regx.exec(imgUrl);
}

function formatChild(note) {
    var nodes = note.childNodes;
    var canBreak = 0;
    for (var i = nodes.length - 1; i >= 0; i--) {
        if (nodes[i].nodeType == 1 && nodes[i].nodeName == "P" && nodes[i].getAttribute("class") !== "placeholder") {
            var cNodes = nodes[i].childNodes;
            for (var j = 0; j < cNodes.length; j++) {
                if (cNodes[j].nodeType == 1) {
                    if (j == cNodes.length - 1 && (cNodes[j].nodeName == "STRONG" || cNodes[j].nodeName == "SPAN")) {
                        if (cNodes[j].childNodes.length > 0 && cNodes[j].childNodes[0].nodeName !== "SMALL") {
                            if (!canBreak) {
                                canBreak = 1;
                            }
                            break;
                        }
                    }
                } else if (cNodes[j].nodeType == 3) {
                    var inner = getHtmlByJQuery(cNodes[j].parentNode);
                    if (inner) {
                        if (!canBreak) {
                            canBreak = 1;
                        }
                        break;
                    }


                }
            }
        }
    }
    return note;
}

function dealTelephoneComponent() {

    var container = document.getElementById('content');
    var telephoneComponent = container.getElementsByClassName('telephone');

    if (telephoneComponent && telephoneComponent.length > 0) {
        var telphoneLabel;
        for (var i = 0; i < telephoneComponent.length; i++) {
            telphoneLabel = telephoneComponent[i];
            telphoneLabel.onclick = function() {
                //sendWebLog('text telephone', "you click : "+this.innerText);
                ifeng.makeTelephone(this.innerText);
            };
        }
    }
}

// 滚动加载图片
function loadImages() {
    if (document.getElementById('advertdiv')) {
        ifeng.setCenterAdPosition(offsetTop(document.getElementById('advertdiv')));
    }
    var container = document.getElementById('content'),
        placeholders = Array.prototype.slice.call(container.getElementsByClassName('placeholder')),
        src, docId = datas.getDocumentId(),
        loadMessage = getLoadingImage();

    var videoComponent = container.getElementsByClassName('video');

    var slideComponent = container.getElementsByClassName('slide');

    var advertComponent = container.getElementsByClassName('advert');

    var videoJumpComponent = container.getElementsByClassName('video-bottom');

    var tipContainer = document.getElementById('news-content');
    var tipPlaceHolders = Array.prototype.slice.call(tipContainer.getElementsByClassName('placeholder'))

    if (placeholders && placeholders.length >= 0 && tipPlaceHolders && tipPlaceHolders.length > 0) {
        placeholders = placeholders.concat(tipPlaceHolders);
    }

    //加载视频图片
    for (var i = 0; i < videoComponent.length; i++) {
        var videoDom = videoComponent[i];
        var jumpDom = videoJumpComponent[i];
        imgQuene.push({
            ot: videoDom.offsetTop,
            dom: videoDom,
            src: videoDom.getAttribute('imgsrc')
        })
        videoDom.onclick = function() {
            loadState = this.getAttribute('loadState');
            if (loadState == 'loadFail') {
                //如果没有网络连接，直接提示无网络
                if (ifeng.checkNetWorkState() == 0) {
                    return;
                }
                src = this.getAttribute('imgsrc');
                handle_video_message(this, 1);
                this.setAttribute('loadState', 'loading');
                Ground.loadImageDirectly(src, docId,
                    loadImageSuccessInterceptor(this),
                    loadImageFailInterceptor(this, src), 'forceLoad');
            }
            ifeng.playVideo(window.devicePixelRatio * videoDom.clientWidth,window.devicePixelRatio * this.clientHeight, window.devicePixelRatio * getLeft(this), window.devicePixelRatio * getTop(this), this.getAttribute('normalSrc'), this.getAttribute('HDSrc'), this.getAttribute('videoType'), this.getAttribute('duration'), this.getAttribute('guid'), this.getAttribute('staticId'), this.getAttribute('columnId'), this.getAttribute('title'), this.getAttribute('thumbnail'));
        };

        /***
         * 打开凤凰视频app or 下载凤凰视频app。
         */
        if (jumpDom) {
            jumpDom.onclick = function() {
                var guid = this.getAttribute('guid');
                ifeng.jumpIfengVideoApp(guid);
            };
        }
    }

    //加载中心广告图片
    for (var i = 0; i < advertComponent.length; i++) {
        var advertDom = advertComponent[i];
        imgQuene.push({
            ot: advertDom.offsetTop,
            dom: advertDom,
            src: advertDom.getAttribute('advertsrc')
        })
        document.getElementById('advertdiv').style.width = ifeng.getScreenWidth() - 60 + 'px';
        document.getElementById('advertdiv').style.height = Math.round((ifeng.getScreenWidth() - 120) / BODY_AD_CENTER_RADIO) + 'px';
        advertDom.onclick = function() {
            index = parseInt(this.getAttribute('index'));
            src = this.getAttribute('advertsrc');
            isLoaded = (this.className).indexOf('loaded') > -1;
            loadState = this.getAttribute('loadState');
            if (isLoaded) {
                ifeng.centerAdClick();
            } else {
                if (loadState == 'loadFail') {
                    //如果没有网络连接，直接提示无网络
                    if (ifeng.checkNetWorkState() == 0) {
                        return;
                    }
                    setHtmlByJQuery(this, loadMessage);
                    this.setAttribute('loadState', 'loading');
                    Ground.loadImageDirectly(src, docId,
                        loadImageSuccessInterceptor(this),
                        loadImageFailInterceptor(this, src), 'forceLoad');
                }
            }
        };
    }
    //加载图集图片
    for (var i = 0; i < slideComponent.length; i++) {
        var slideDom = slideComponent[i];
        imgQuene.push({
            ot: slideDom.offsetTop,
            dom: slideDom,
            src: slideDom.getAttribute('slidesrc')
        })

        slideDom.onclick = function() {
            index = parseInt(this.getAttribute('index'));
            src = this.getAttribute('slidesrc');
            isLoaded = (this.className).indexOf('loaded') > -1;
            loadState = this.getAttribute('loadState');
            if (isLoaded) {
                ifeng.goToSlide(this.getAttribute('src'));
            } else {
                if (loadState == 'loadFail') {
                    //如果没有网络连接，直接提示无网络
                    if (ifeng.checkNetWorkState() == 0) {
                        return;
                    }
                    setHtmlByJQuery(this, loadMessage);
                    this.setAttribute('loadState', 'loading');
                    Ground.loadImageDirectly(src, docId,
                        loadImageSuccessInterceptor(this),
                        loadImageFailInterceptor(this, src), 'forceLoad');
                }
            }
        };
    }

    for (var i = 0; i < placeholders.length; i++) {
        var imgDom = placeholders[i];
        src = imgDom.getAttribute('src');
        //   console.log('img '+i+' offsetTop=' + imgDom.offsetTop);
        imgQuene.push({
            ot: imgDom.offsetTop,
            dom: imgDom,
            src: src
        })
        // 点击判断加载状态 执行重新加载 或 显示幻灯
        imgDom.onclick = function(i) {
            var index, src, isLoaded, loadState;
            index = parseInt(this.getAttribute('index'));
            src = this.getAttribute('src');
            isLoaded = (this.className).indexOf('loaded') > -1;
            loadState = this.getAttribute('loadState');
            if (isLoaded) {
                ifeng.popupLightbox(srcs, index, this.getAttribute('jumpUrl'));
            } else {
                if (loadState == 'loadFail') {
                    //如果没有网络连接，直接提示无网络
                    if (ifeng.checkNetWorkState() == 0) {
                        return;
                    }
                    setHtmlByJQuery(this, loadMessage);
                    this.setAttribute('loadState', 'loading');
                    Ground.loadImageDirectly(src, docId,
                        loadImageSuccessInterceptor(this),
                        loadImageFailInterceptor(this, src), 'forceLoad');
                }
            }
        };
    }

    // 开始加载所有正文图片
    for (var j = 0, len = imgQuene.length, load; j < len; j++) {
        var d = imgQuene[j];
        if (d.dom.getAttribute('imgsrc')) {
            handle_video_message(d.dom, 1);
        }
        load = true;
        Ground.loadImage(d.src, docId,
            loadImageSuccessInterceptor(d.dom, j),
            loadImageFailInterceptor(d.dom, d.src), 'false', load);

    }
    ifeng.startDownload();
}

/*
 处理视频图片加载状态
 state
 0 未加载
 1 正在加载
 2 加载失败
 3 加载成功显示btn
 4 加载成功不显示btn
 */
function handle_video_message(item, state) {
    try {
        var loadMessage = '';
        switch(state) {
            case 0:
            case 2:
                setHtmlByJQuery(item, getLoadingImage());
                break;
            case 1:
                loadMessage = getLoadingImage();
                setHtmlByJQuery(item, loadMessage+'<div class="video_bottom_content_hide"><div class="video_right_button"><img src="video_button.png"/></div></div>');
                break;
            case 3:
                setHtmlByJQuery(item, '<div class="video_bottom_content_show"><div class="video_right_button"><img src="video_button.png"/></div></div>');
                break;
            case 4:
                item.textContent = '';
                break;
        }
    }catch(e){console.log("error:"+e);};
}

// 图片加载的成功回调
function loadImageSuccessInterceptor(placeholder, imgPosition) {
    return function(src) {
        if (placeholder.nodeName != 'IMG') {
            if (placeholder.getAttribute('imgsrc')) {
                handle_video_message(placeholder, 3);
            } else {
                placeholder.textContent = '';
            }
        }
        if (src == "none") {
            placeholder.setAttribute('loadState', 'loadFail');
            return;
        }

        //加载成功了
        var className = placeholder.className;
        //		imgQuene[imgPosition] = false;
        if (className.indexOf('loaded') > -1) {
            return;
        }
        if (placeholder.getAttribute('commentImageSrc') || placeholder.getAttribute('likeSrc') || placeholder.getAttribute('recommendSrc') || placeholder.getAttribute('readImgSrc')) {
            placeholder.src = src;
        } else if (placeholder.getAttribute('imgsrc')) {
            placeholder.style.backgroundSize = '100%,100%';
            placeholder.style.backgroundImage = 'url(' + src + ')';
        } else if (placeholder.getAttribute('advertsrc')) {
            document.getElementById('advertdiv').style.width = ifeng.getScreenWidth() - 60 + 'px';
            document.getElementById('advertdiv').style.height = Math.round((ifeng.getScreenWidth() - 120) / BODY_AD_CENTER_RADIO) + 'px';
            placeholder.src = src;

            var adCloseEl = document.getElementById('ad-close');
            adCloseEl.onclick = function(event) {
                ifeng.setCenterAdHint();
                document.getElementById('advertdiv').style.display = 'none';
                event.stopPropagation();
            };
            if (datas.getDocAdClose() == '1') {
                adCloseEl.style.display = 'visibility';
            } else {
                adCloseEl.style.display = 'none';
            }
            ifeng.setCenterAdPosition(offsetTop(document.getElementById('advertdiv')));
            ifeng.setCenterAdHeight(Math.round((ifeng.getScreenWidth() - 120) / BODY_AD_CENTER_RADIO));
        } else if (placeholder.getAttribute('slidesrc')) {
            placeholder.style.backgroundImage = 'url(slide_text.png),url(' + src + ')';
            placeholder.style.backgroundSize = '40px 22px,cover';
        } else if (placeholder.getAttribute('placeholder_tag')) {
            setHtmlByJQuery(placeholder, getLoadedImage());
            placeholder.style.backgroundSize = '100%,100%';
            placeholder.style.backgroundColor = 'transparent';
            placeholder.style.backgroundPosition = 'center top';
            showLoadedImage(placeholder, src);
        } else {
            placeholder.style.backgroundSize = '100%,100%';
            placeholder.style.backgroundImage = 'url(' + src + ')';
            placeholder.style.backgroundPosition = 'center top';
            placeholder.style.backgroundColor = 'transparent';
        }
        placeholder.className = className + ' loaded';

    };
}

function getLoadedImage() {
    var loaded = '<img id="loadedImg" style="width: 100%; height: auto; border-radius:4px;"/>'
    return loaded;
}

function showLoadedImage(placeholder, imgUrl) {
    if (placeholder.getAttribute('placeholder_tag')) {
        var loadedImg = placeholder.firstChild;
        loadedImg.setAttribute('src', imgUrl);

        // 如果是默认高度，设置img的展示方式，等比例缩放至适配容器大小
        if(placeholder.style.height === IMAGE_PLACEHOLDER_HEIGHT+'px'){
            loadedImg.style.objectFit = 'contain';
        }
    }
}

function loadImageFailInterceptor(placeholder, src) {
    return function() {
        if (placeholder.nodeName != 'IMG') {
            if (placeholder.getAttribute('imgsrc')) {
                handle_video_message(placeholder, 2);
            } else {
                setHtmlByJQuery(placeholder, getLoadedImage());
            }
        }
        if (placeholder.getAttribute('recommendSrc') || placeholder.getAttribute('readImgSrc')) {
            placeholder.src = 'list_default.jpg';
        } else if (placeholder.getAttribute('likeSrc')) {
            placeholder.src = 'album_default.JPG';
        }
        placeholder.setAttribute('loadState', 'loadFail');
        sendWebLog('loadImageFailInterceptor load img fail', src);
    };
}

// 订阅模块加载失败回调
function loadSubscriptImageFailInterceptor(placeholder, src) {
    return function() {
        placeholder.style.backgroundPosition = 'center top';
        placeholder.setAttribute('loadState', 'loadFail');
        sendWebLog('loadSubscriptImageFailInterceptor load img fail', src);
    };
}

// 与native交互实现
(function() {
    var toString = function(v) {
            return Object.prototype.toString.call(v);
        },
        isFunction = function(v) {
            return toString(v) === '[object Function]';
        },
        athene = {},
        CALLBACK_PREFIX = 'callback__',
        doc_update_time_prefix = 'none__',
        callbacks = {},
        callbackCount = 0,
        CallbackStatus = {
            OK: 1
        };
    athene.exec = function(success, fail, service, action, params) {
        //增加正文更新时间，图片加载为异步，若正文有更新，则抛弃任务
        var callbackId = CALLBACK_PREFIX + doc_update_time_prefix + callbackCount++;
        callbacks[callbackId] = {
            success : success,
            fail : fail
        };
        params = Array.prototype.concat.call([], callbackId, params || []);
        action.apply(service, params);
    };
    athene.complete = function() {
        if (arguments.length < 2) {
            throw new Error('Missing essential arguments');
        }
        var callbackId = arguments[0],
            status = arguments[1],
            callback = callbacks[callbackId],
            params = Array.prototype.slice
            .call(arguments, 2),
            success, fail;
        delete callbacks[callbackId];
        if (!callback) {
            return;
        }
        success = callback.success;
        fail = callback.fail;
        if (status == CallbackStatus.OK && isFunction(success)) {
            success.apply(null, params);
//            console.log('params= '+ params[0]);
        } else if (isFunction(fail)) {
            fail.apply(null, params);
        }
    };
    athene.clear = function() {
            callbacks = {};
            callbackCount = 0;
        };
    athene.setUpdateTime = function(updateTime) {

        if(updateTime != null && updateTime != "null" && updateTime != ""
            && updateTime != 'undefined'&& Object.prototype.toString.call(updateTime) == '[object String]'){
                doc_update_time_prefix = updateTime + "__";
        }
    };
    window['athene'] = athene;
})();

// ground 接口
(function() {
    var Ground = {
        loadImage: function(src, documentId, success, fail, forceLoad, load) {
            athene.exec(success, fail, ifeng, ifeng.loadImage, [src,
                documentId, forceLoad, load
            ]);
        },
        loadImageDirectly: function(src, documentId, success, fail, forceLoad) {
            athene.exec(success, fail, ifeng, ifeng.loadImageDirectly, [src, documentId,
                forceLoad
            ]);
        },
        loadUserHeadImageDirectly: function(src, documentId, success, fail, forceLoad) {
            athene.exec(success, fail, ifeng, ifeng.loadUserHeadImageDirectly, [src, documentId,
                forceLoad
            ]);
        },
        addSubscribe: function(success, fail) {
            athene.exec(success, fail, ifeng, ifeng.addSubscribe);
        },
        addSubscribeViewPoint:function(success,fail){
              athene.exec(success, fail, ifeng, ifeng.addSubscribeViewPoint);
        },
        isSubscribe: function(success, fail) {
            athene.exec(success, fail, ifeng, ifeng.isSubscribe);
        },
        isSubscribeViewPoint: function(success, fail) {
             athene.exec(success, fail, ifeng, ifeng.isSubscribeViewPoint);
        }
    };

    window['Ground'] = Ground;
})();

function renderAudio(i) {
    var container = document.getElementById('content');
    var audioComponent = container.getElementsByClassName('audio');
    if(i >= audioComponent.length) {
        ifeng.resumeRenderPlaceHolderViews();
        return;
    }

    var audioDom = audioComponent[i];
    //audioDom.clientHeight，getleft(audioDom)获取的值在低版本（4.4以下）中是错误的
    //为了兼容低版本手机控件高度写死为60，左边距15；
    ifeng.initAudioLayout(window.devicePixelRatio * 70, window.devicePixelRatio, window.devicePixelRatio * (getTop(audioDom) + 10), audioDom.getAttribute('title'), audioDom.getAttribute('desc'), audioDom.getAttribute('thumbnail'), audioDom.getAttribute('duration'), audioDom.getAttribute('srcNor'), audioDom.getAttribute('srcHD'), audioDom.getAttribute('guid'),datas.getDocumentId(),audioDom.getAttribute('staticId'));
}

//检测正文content的高度，当有变化时进行通知
//Js的MutationObserver不兼容大于37版本的Android WebView，某些低版本手机无法支持，这里依赖原生轮询调用
//https://developer.mozilla.org/zh-CN/docs/Web/API/MutationObserver
function notifyIfContentHasHeight() {

    if(originalHeight == null || originalHeight == undefined) {
        console.log("originalHeight is undefined now, please wait.")
        return;
    }

    var content = document.getElementById('content');
    if (content != null && content != undefined) {
       var currentHeight = content.clientHeight;
        if (currentHeight > originalHeight) {
            ifeng.notifyOnContentHasHeight(currentHeight);
            console.log("notifyIfContentHasHeight " + currentHeight)
        }
    }
}

//计算行数
 function getContentLength(rects) {
 	var line = 0,
 		lastBottom = 0;
 	for (var i = 0, len = rects.length; i < len; i++) {
 		if (rects[i].bottom == lastBottom) {
 			continue
 		}
 		lastBottom = rects[i].bottom;
 		line++;
 	}
 	return line;
 }
 //展开跟收起的监听
function injectExpendContentAction(contentTxtDom, rows) {
	var originalText = getHtmlByJQuery(contentTxtDom); // 源数据存储变量
	var changeText = getHtmlByJQuery(contentTxtDom); // 计算数据变量
	var contentRects = contentTxtDom.getClientRects();
	var h = getContentLength(contentRects); //行数
	while (h > rows) {
		var step = 1;
		changeText = changeText.slice(0, -step);
		var html = changeText + '<span>...</span><span id="collapse-btn" class="collapse-text" data-spread="false"> 展开</span>';
		setHtmlByJQuery(contentTxtDom, html);
		h = getContentLength(contentTxtDom.getClientRects());
	}

	window.addEventListener('click', function(e) {
	    console.log(e.target);
        if(e.target.id !== 'collapse-btn'){
           return;
        }
		var state = document.getElementById('collapse-btn').dataset.spread;
	    var isNightMode = ifeng.isNightMode();
		if (state === 'false') {
		    if(isNightMode){
		       var html = originalText + '<span id="collapse-btn" class="collapse-text" data-spread="true" style="float: right;color: #2A7FD3;">收起</span>'
		       setHtmlByJQuery(contentTxtDom, html);
		    }else{
		       var html = originalText + '<span id="collapse-btn" class="collapse-text" data-spread="true" style="float: right;color: #3091F5;">收起</span>'
		       setHtmlByJQuery(contentTxtDom, html);
		    }

		} else {
		      if(isNightMode){
		          var html = changeText + '<span>...</span><span id="collapse-btn" class="collapse-text" data-spread="false" style="color: #2A7FD3"> 展开</span>'
		          setHtmlByJQuery(contentTxtDom, html);
		      }else{
		          var html = changeText + '<span>...</span><span id="collapse-btn" class="collapse-text" data-spread="false" style="color:#3091F5"> 展开</span>'
		          setHtmlByJQuery(contentTxtDom, html);
		      }

		}
		ifeng.startRenderPlaceHolderViews();

	}
	);
}

//折叠屏状态变化兼容。在原生View都加在完成时，更新播放器的位置与尺寸
//如果变化前视频正在播放或处于全屏状态，则自动滚动到播放器位置
function updateVideoUi(videoGuid, autoScroll) {
    var container = document.getElementById('content');
    var videoComponent = container.getElementsByClassName('video');
    for (var i = 0; i < videoComponent.length; i++) {
        var videoDom = videoComponent[i];
        var guid = videoDom.getAttribute('guid');
        if (guid == videoGuid) {

			var top = window.devicePixelRatio * getTop(videoDom);
            if (autoScroll) {
                ifeng.scrollToY(top);
            }

            ifeng.updateVideoUiInfo(
                window.devicePixelRatio * videoDom.clientWidth,
                window.devicePixelRatio * videoDom.clientHeight,
                window.devicePixelRatio * getLeft(videoDom),
                top,
                guid
            );
            return;
        }
    }
    ifeng.resumeRenderPlaceHolderViews();
}

//重置img标签的加载状态
function resetImgLabel() {
    try {
        var content = document.getElementById('content');
        var imgs = Array.prototype.slice.call(content.getElementsByTagName('img'));
        for (var i = 0; i < imgs.length; i++) {
            var img = imgs[i];
            img.classList.remove("loaded");
        }
    } catch (e) {
        console.log("error:" + e);
    };
}

//人设观点部分 头像信息
function initViewPointSource(datas) {
	try {
		var wrapper = document.getElementById('time-and-source-panel_viewpoint');
		var jumpState = datas.getViewPointSubscribe().getForbidJump();
		wrapper.onclick = function(event) {
			if (jumpState == 0) {
				ifeng.gotoSubscribe("ViewPoint");
				event.stopPropagation();
			}
		}

		// 头像布局
		var icon = document.getElementById('source_icon_viewpoint');
		var iconTag = document.getElementById('source_tag_viewpoint');

		// 设置自媒体头像
		var source_tag, imgPath, projectName, projectDes, cateSourceTag;
		if (datas.getViewPointSubscribe()) {
			imgPath = datas.getViewPointSubscribe().getLogo();
			projectName = datas.getViewPointSubscribe().getCatename();
			projectDes = datas.getViewPointSubscribe().getDescription();
			cateSourceTag = datas.getViewPointSubscribe().getCateTagForJs(); //标签
			if (ifeng.isNightMode()) {
				source_tag = datas.getViewPointSubscribe().getHonorImgNight();
			} else {
				source_tag = datas.getViewPointSubscribe().getHonorImg();
			}
		}
		if (typeof(imgPath) != "undefined") {
			icon.style.display = 'block';
			Ground.loadUserHeadImageDirectly(imgPath, null,
				loadImageSuccessInterceptor(icon),
				loadSubscriptImageFailInterceptor(icon, imgPath), 'forceLoad');
		} else {
			icon.style.display = "none";
		}

		// 荣誉认证V
		if (source_tag && typeof(source_tag) != "undefined" && source_tag != null && source_tag != "" && source_tag != 0) {
			iconTag.style.display = "block";
			Ground.loadImageDirectly(source_tag, null,
				loadImageSuccessInterceptor(iconTag),
				loadSubscriptImageFailInterceptor(iconTag, source_tag), 'forceLoad');
		}else{
		    iconTag.style.display = "none";

		}
		// 自媒体名称
		var sourceName = document.getElementById('wrap_source_catesource_viewpoint');
		var sourceProject = document.getElementById('wrap_time_original_viewpoint');

		var catesource=document.getElementById('catesource_tag');
        	//标签
       	if (cateSourceTag != null && typeof(cateSourceTag) != "undefined" && cateSourceTag != "") {
        		catesource.textContent = cateSourceTag;
        	} else {
        		catesource.style.display = "none"
        }
		//名称
		if(projectName!=null&&typeof(projectName) != "undefined"&&projectName!=""){
			sourceName.textContent = projectName;
		}else{
		    sourceName.style.display="none"
		}
		//描述
		if(projectDes!=null && typeof(projectDes) != "undefined" && projectDes!=""){
			sourceProject.textContent = projectDes;

        }else{
        	sourceProject.style.display="none"
        }

        //订阅的状态
        Ground.isSubscribeViewPoint(subSourceSuccessForViewPoint(),"");

		//订阅的点击事件
		var video_button = document.getElementById('subscribe_viewpoint');
	    if(datas.getViewPointSubscribe()!= null && datas.getViewPointSubscribe().getForbidFollow()=='1'){
            video_button.style.display = "none";
        }


		video_button.onclick = function(event) {
			Ground.addSubscribeViewPoint(subSourceSuccessForViewPoint(), "");
			event.stopPropagation();
		};

	} catch (e) {
		console.log("error:" + e);
	}
}

/* 展示正文开始 */
function initDocStart(datas) {
	var docStart = document.getElementById('content-start');

	if (datas.getViewpointShowHead() == "1") {

		docStart.style.display = "block";

	} else {
		docStart.style.display = "none";

	}

}

//初始化人设观点
function initViewPoint(datas) {
	initViewPointSource(datas)
	try {
		var pointContainer = document.getElementById('doc_viewpoint');
		if (datas.getViewpoint()) {
			pointContainer.style.display = 'block';
		} else {
			pointContainer.style.display = 'none';
		}
		initPointContent(datas)
	} catch (e) {
		console.log("initViewPoint error : " + e);
	}
}

//人设 观点 以及建议阅读时长
function initPointContent(datas) {
	var point = datas.getViewpoint();
	if (point) {
		var time = datas.getReadingTips();
		var rows = datas.getViewpointFold();
		var pointContentDom = document.getElementById('point_content');
		pointContentDom.textContent = point;
		injectExpendContentAction(pointContentDom, rows);
		var pointTimeTip = document.getElementById('point_time');
		if (time) {
			pointTimeTip.style.display = 'block';
			pointTimeTip.textContent = time;
		} else {
			pointTimeTip.style.display = 'none';
		}
	}
}

/* 观点部分 切换订阅按钮状态*/
function subSourceSuccessForViewPoint() {
	return function(subState) {
		var subButton = document.getElementById('subscribe');
		var subText = document.getElementById('subscribe_viewpoint');

		var subId = datas.getSubscribe().getFollowId();
		var viewSubId = datas.getViewPointSubscribe().getFollowId();
		//相等的时候需要联动
		var isNightMode = ifeng.isNightMode();
		if (subState) {
			var delSubImg = "followed_day.png";
			if (isNightMode) {
				delSubImg = "followed_night.png";
			}
			if (subId == viewSubId) {
				subButton.setAttribute("src", delSubImg);
			}

			subText.style.color = "#9E9E9E";
			subText.textContent = "已订阅";

		} else {
			var addSubImg = "follow_day.png";
			if (isNightMode) {
				addSubImg = "follow_night.png";
			}
			if (subId == viewSubId) {
				subButton.setAttribute("src", addSubImg);
			}
			subText.style.color = "#F54343";
			subText.textContent = "订阅";

		}
		console.log("subSourceSuccessForViewPoint");
	};
}

/* 使用JQuery的html函数代替innerHtml函数，降低XSS攻击风险 */
function setHtmlByJQuery(element,htmlStr) {
	if(!isFieldValid(element)) {
		return;
	}
	$(element).html(htmlStr);
}

function getHtmlByJQuery(element) {
	if(!isFieldValid(element)) {
		return '';
	}
	return $(element).html();
}

function showSubPlaceHolderView() {
	var subButton = document.getElementById('subscribe');
    if(isFieldValid(subButton) && subButton.style.display != 'none') {
        var top = window.devicePixelRatio*getTop(subButton);
        var left = window.devicePixelRatio * getLeft(subButton);
        var width = window.devicePixelRatio*subButton.clientWidth;
        var height = window.devicePixelRatio*subButton.clientHeight;
        ifeng.addSubPlaceHolderView(left,top,width,height);
    } else {
        ifeng.resumeRenderPlaceHolderViews();
    }
}

function initAiIntroView() {
    var id = "ai_intro";
    var ai_intro = document.getElementById(id);
    if (isFieldValid(ai_intro)) {
        var aiIntro = datas.getSummaryai()
        if (isFieldValid(aiIntro)) {
            ai_intro.style.height = '60px';
        } else {
            ai_intro.style.height = '0px';
        }
    }
}

function showAiIntroView(indexInAllType) {
    var id = "ai_intro";
    var ai_intro = document.getElementById(id);
    if (isFieldValid(ai_intro)) {
        var top = window.devicePixelRatio * getTop(ai_intro);
        ifeng.showAiIntroView(top, id, indexInAllType);
    }
}

function refreshNativeVideoPlayerPosition() {
	var playingVideoGuid = ifeng.getPlayingVideoGuid();
    if (isFieldValid(playingVideoGuid)) {
        updateVideoUi(playingVideoGuid, false);
    } else {
        ifeng.resumeRenderPlaceHolderViews();
    }
}

function refreshWebWrapperHeightIfFromFold() {
	ifeng.refreshWebWrapperHeightIfFromFold();
}

//软广告标识
function initAdvertFlag(datas) {

	try {
		var advertContainer = document.getElementById('advert_flag');
		if (datas.getAdMarkText()) {
			advertContainer.style.display = 'block';
			advertContainer.textContent = datas.getAdMarkText();
			 //有 核心提示 的时候，修改上边距
			 var tip = datas.getIntroduction();
             if (tip && Object.prototype.toString.call(tip) == '[object String]') {
                 advertContainer.style.paddingTop = "20px";
             } else {
                 advertContainer.style.paddingTop = "10px";
             }
             //观点
             var point = datas.getViewpoint();
             if (point) {
                 document.getElementById('doc_viewpoint').style.marginTop = "0px";
                 return;
             }
             //
             var topbanner = datas.getTopbanner();
             if (topbanner) {
                 document.getElementById('doc_banner_wrap').style.marginTop = "0px";
                 return;
             }
             //
             var declare = datas.getSubscribe().getDeclare();
             if (declare &&  declare != "undefined") {
                 document.getElementById('detail_declare').style.marginTop = "0px";
                 return;
             }
             //
             var summary = datas.getSummary();
             if (summary) {
                 document.getElementById('summary_parent').style.marginTop = "0px";
                 advertContainer.style.paddingBottom = "7px";
                 //document.getElementById('square_top').style.marginTop = "0px";
                 //document.getElementById('line_top').style.marginTop = "0px";
                 return;
             }
             //
/*             var aiIntro = datas.getSummaryai()
             if (aiIntro) {
                 document.getElementById('ai_intro').style.marginTop = "0px";
                 return;
             }*/
		} else {
			advertContainer.style.display = 'none';
			return;
		}
	} catch (e) {
		console.log("initAdvertFlag error : " + e);
		return;
	}
}

//早晚报图片在包框里，按屏幕宽度计算图片高度，会存在拉伸问题。需要按比例缩放
function fixDailyNewsImgHeight() {
    if (!ifeng.isDailyNews()) {
        return
    }

    try {
        var fixedClass = 'height_fixed';
        var placeholders = document.getElementsByClassName('placeholder');
        for (var j = 0; j < placeholders.length; j++) {
            var placeholder = placeholders[j];
            if (placeholder.classList.contains(fixedClass)) {
                //处理过的不需要处理
                continue;
            }

            if (placeholder.style.width != "") {
                //宽度不是填充，不需要处理
                continue;
            }

            var boundingBox = placeholder.getBoundingClientRect();
            var distanceToLeft = Math.round(boundingBox.left);
            if (!isFieldValid(distanceToLeft) || distanceToLeft <= 14) {
                //本地默认间距，不需要处理
                continue;
            }

//            console.log('距离屏幕左边：', distanceToLeft, 'px');

            var width = SCREEN_WIDTH - 2 * distanceToLeft;
            var originalHeight = parseInt(placeholder.style.height);
            var ratio = width / IMAGE_PLACEHOLDER_WIDTH;
//            console.log('默认宽度：', SCREEN_WIDTH, 'px', ' 实际宽度：', width, 'px', ' 宽度比例：', ratio);
            var newHeight = Math.round(originalHeight * ratio);
            placeholder.style.height = placeholder.style.minHeight = newHeight + 'px';
            console.log('原始高度：', originalHeight, 'px', ' 修正高度：', placeholder.style.height);
            placeholder.classList.add(fixedClass);
        }
    } catch (e) {
        console.log("fixDailyNewsImgHeight error : " + e);
        return;
    }
}